/* gcc_cpp */
#include <cstdio>
#include <queue>

using namespace std;

const char *infile="islands.dat";
const char *outfile="islands.sol";

const int maxMN=500;
const int maxIslands=maxMN*maxMN;
const int maxE=maxMN*maxMN*2;
const int inf=maxMN*maxMN*5+5;
const int dr[4]={-1,0,0,1};
const int dc[4]={0,-1,1,0};

struct edge {
    int w,len;
    edge *next;
    edge(int W=0,int Len=0,edge *Next=0):w(W),len(Len),next(Next) {}
};
struct pqel {
    int v,dist;
    pqel(int V=0,int D=0):v(V),dist(D) {}
    bool operator<(const pqel &pq)const {return dist>pq.dist;}
};
edge *adj[maxIslands+1];
edge edgs[maxE];
int dist[maxIslands+1];
int eCnt;
char field[maxMN][maxMN+5];
int n,m;
int island[maxMN][maxMN];
int q[maxMN*maxMN][2];

void AddEdge(int v,int w,int len) {
    adj[v]=&(edgs[eCnt++]=edge(w,len,adj[v]));
    adj[w]=&(edgs[eCnt++]=edge(v,len,adj[w]));
}
int main() {
    int i,j,beg,r,c;
    int iCnt,qb,qe;
    int ans,d,rCnt;
    edge *e;
    priority_queue<pqel> pq;
    FILE *ifs=fopen(infile,"r");
    FILE *ofs=fopen(outfile,"w");
    
    fscanf(ifs,"%d%d\n",&n,&m);
    for(i=0;i<n;i++)
        fscanf(ifs," %s",field[i]);
    iCnt=0;
    for(i=0;i<n;i++)
        for(j=0;j<m;j++)
            if(field[i][j]=='1'&&!island[i][j]) {
				qb=qe=0;++iCnt;
				q[qe][0]=i;q[qe][1]=j;qe++;
				island[i][j]=iCnt;
                while(qb!=qe) {
					r=q[qb][0];c=q[qb][1];qb++;
					for(d=0;d<4;d++)
        				if(r+dr[d]>=0&&r+dr[d]<n&&c+dc[d]>=0&&c+dc[d]<m&&
            				field[r+dr[d]][c+dc[d]]=='1'&&!island[r+dr[d]][c+dc[d]]) {
								island[r+dr[d]][c+dc[d]]=iCnt;
								q[qe][0]=r+dr[d];q[qe][1]=c+dc[d];qe++;
                			}
				}
			}
    for(i=0;i<n;i++) {
        for(beg=m+1,j=0;j<m;j++)
            if(field[i][j]=='1') {
                if(j-beg>1&&island[i][j]!=island[i][beg])
                    AddEdge(island[i][j],island[i][beg],j-beg-1);
                beg=j;
            }
    }            
    for(j=0;j<m;j++) {
        for(beg=n+1,i=0;i<n;i++)
            if(field[i][j]=='1') {
                if(i-beg>1&&island[i][j]!=island[beg][j])
                    AddEdge(island[i][j],island[beg][j],i-beg-1);
                beg=i;
            }
    }
    for(i=1;i<=iCnt;i++)dist[i]=inf;
    dist[1]=0;
    pq.push(pqel(1,dist[1]));
    ans=0;rCnt=0;
    while(!pq.empty()) {
        i=pq.top().v;
        d=pq.top().dist;
        pq.pop();
        if(dist[i]==d) {
            ans+=d;
            dist[i]=-1;
            rCnt++;
            for(e=adj[i];e;e=e->next)
                if(dist[e->w]>e->len) {
                    dist[e->w]=e->len;
                    pq.push(pqel(e->w,dist[e->w]));
                }
        }
    }
    if(rCnt==iCnt)fprintf(ofs,"%d\n",ans);
    else fprintf(ofs,"-1\n");	
    fclose(ifs);
    fclose(ofs);
    return 0;   
}
