/* vc_cpp */
#include <vector>
#include <algorithm>
#define _USE_MATH_DEFINES
#include <math.h>
#include <assert.h>

using namespace std;

FILE * fin = fopen("points.dat", "r");
FILE * fout = fopen("points.sol", "w");

struct point
{
	int x, y;
};

struct pointA
{
	int x, y;
	double a;

	pointA () {}

	pointA (point p, double A)
	{
		x = p.x;
		y = p.y;
		a = A;
	}
};

bool cmpA (pointA a, pointA b)
{
	if (fabs(fabs(a.a) - fabs(b.a)) < 1e-9) {
		bool nA, nB;
		nA = a.a < 0;
		nB = b.a < 0;
		if (nA && !nB)
			return true;
		return false;
	}
	return fabs(a.a) < fabs(b.a);
}

bool cmpB (pointA a, pointA b)
{
	if (fabs(fabs(a.a) - fabs(b.a)) < 1e-9) {
		bool nA, nB;
		nA = a.a < 0;
		nB = b.a < 0;
		if (nB && !nA)
			return true;
		return false;
	}
	return fabs(a.a) < fabs(b.a);
}

bool cmp3 (pointA a, pointA b)
{
	if (fabs(fabs(a.a) - fabs(b.a)) < 1e-9) {
		bool nA, nB;
		nA = a.a < 0;
		nB = b.a < 0;
		if (nA)
			return true;
		return false;
	}
	return fabs(a.a) < fabs(b.a);
}

inline double angle (point A, point O, point B)
{
	A.x -= O.x;
	A.y -= O.y;
	B.x -= O.x;
	B.y -= O.y;

	double a = atan2((double)(- A.x * B.y + A.y * B.x), (double)(A.x * B.x + A.y * B.y));
	//if (a < 0)		a += 2 * M_PI;
	if (a < 0)
		a = -a - M_PI;
	return a;
}

int n;
point A, B;
vector<pointA> pA, pB;
vector<bool> pres;

int main ()
{
	int i, j, ans, always;
	ans = always = 0;
	fscanf(fin, "%d", &n);
	fscanf(fin, "%d%d%d%d", &A.x, &A.y, &B.x, &B.y);

	assert(A.x != B.x || A.y != B.y);

	point O;
	
	O.x = A.x - (B.x - A.x);
	O.y = A.y - (B.y - A.y);

	point p;
	for (i = 0; i < n; ++i) {
		fscanf(fin, "%d%d", &p.x, &p.y);
		if (p.x == A.x && p.y == A.y ||
			p.x == B.x && p.y == B.y) {
			always ++;
			ans ++;
		}
		else {
			double a = angle(O, A, p);
			if (fabs(a) < 1e-9 || fabs(fabs(a) - M_PI) < 1e-9) {
				ans ++;
			}
			else {
				pA.push_back(pointA(p, angle(O, A, p)));
				pB.push_back(pointA(p, angle(O, B, p)));
			}
		}
	}

	assert(pA.size() == pB.size());

	n = pA.size();

	sort(pA.begin(), pA.end(), &cmpA);
	sort(pB.begin(), pB.end(), &cmpB);

	pres.resize(n, 0);

	int cur;
	cur = 0;
	double a = 0.0;
	for (i=j=0; i < n || j < n;) {
		if (i < n && j < n) {
			if (cmp3(pA[i], pB[j])) {
				if (pA[i].a < 0)
					cur ++;
				else
					cur --;

				i++;
			}
			else {
				if (pB[j].a < 0)
					cur --;
				else
					cur ++;

				j++;
			}
		}
		else if (i < n) {
			if (pA[i].a < 0)
				cur ++;
			else
				cur --;

			i++;
		}
		else if (j < n) {
			if (pB[j].a < 0)
				cur --;
			else
				cur ++;

			j++;
		}
		else
			assert(false);

		ans = max(ans, cur+always);

//		printf("%d\n", cur+always);
	}

	fprintf(fout, "%d\n", ans);

	fclose(fin);
	fclose(fout);
	return 0;
};