/* vc_cpp */
#include <vector>
#include <algorithm>
#define _USE_MATH_DEFINES
#include <math.h>
#include <assert.h>

using namespace std;

#define EPS 1e-9

FILE * fin = fopen("points.dat", "r");
FILE * fout = fopen("points.sol", "w");

struct point
{
	int x, y;
};

inline double vprod(point A, point B, point C)
{
	return (A.x - B.x) * (C.y - B.y) - (A.y - B.y) * (C.x - B.x);
}

int n;
point A, B;
vector<point> p;

int calc (point A, point A_, point B, point B_)
{
	int ans = 0;
	for (int i = 0; i < n; ++i)
	{
		double p1 = vprod(p[i], A, A_);
		double p2 = vprod(p[i], B, B_);

		if (fabs(p1) < EPS || fabs(p2) < EPS)
			ans ++;
		else if (p1 * p2 < 0 && fabs(p1*p2) > EPS)
			ans ++;
	}
	return ans;
}

int main ()
{
	int i, ans;
	point A_, B_;
	ans = 0;
	fscanf(fin, "%d", &n);
	fscanf(fin, "%d%d%d%d", &A.x, &A.y, &B.x, &B.y);

	assert(A.x != B.x || A.y != B.y);

	p.resize(n);
	for (i = 0; i < n; ++i)
		fscanf(fin, "%d%d", &p[i].x, &p[i].y);

	for (i = 0; i < n; ++i)
	{
		A_.x = p[i].x;
		A_.y = p[i].y;

		B_.x = B.x + (A_.x - A.x);
		B_.y = B.y + (A_.y - A.y);

		ans = max(ans, calc(A, A_, B, B_));

		B_.x = p[i].x;
		B_.y = p[i].y;

		A_.x = A.x + (B_.x - B.x);
		A_.y = A.y + (B_.y - B.y);

		ans = max(ans, calc(A, A_, B, B_));
	}

	fprintf(fout, "%d\n", ans);

	fclose(fin);
	fclose(fout);
	return 0;
};