/* gcc_cpp */
#include <assert.h>
#include <vector>
#include <algorithm>

using namespace std;

FILE * fin = fopen ("genome.dat", "r");
FILE * fout = fopen("genome.sol", "w");

struct SET
{
	int s, f, a, b;
};

int n;
vector<int> s;

int main ()
{
	int i, j;

	fscanf(fin, "%d", &n);
	for (i = 0; i < n; i++) {
		SET S;
		fscanf(fin, "%d%d%d%d", &S.s, &S.f, &S.a, &S.b);
		assert(S.a > 0);
		assert(S.b > 0);
		assert(S.s <= S.f);

		for (j = S.s; j <= S.f; j += S.a + S.b)
			for (int k = j; k < j + S.a && k <= S.f; ++k)
				s.push_back(k);
	}

	bool bad = true;
	sort(s.begin(), s.end());
	s.push_back(2000000000);
	n = s.size();
	for (i = j = 0; i < n; ++i) {
		if (i && s[i] == s[i-1])
			j++;
		else if (i) {
			if (j % 2 == 1) {
				fprintf(fout, "%d\n", s[i-1]);
				bad = false;
			}
			j = 1;
		}
		else
			j = 1;
	}

	if (bad)
		fprintf(fout, "0\n");

	fclose(fin);
	fclose(fout);
	return 0;
};