/* gcc_cpp */
#include <cstdio>
#include <iostream>
#include <algorithm>


using namespace std;

const char *infile="genome.dat";
const char *outfile="genome.sol";

const int maxN=10000;

typedef long long ll;

int n;

struct {
    int s,f,a,b;
} sets[maxN];
inline ll ElCnt(int k,int x,int y) {
    ll perbeg,perend,sk,per,s,t,s1,t1;
    ll res=0;
    per=sets[k].a+sets[k].b;
    sk=max(0LL,(max(sets[k].s,x)-sets[k].s+per-1)/per);
    perbeg=sets[k].s+sk*per;
    if(min(sets[k].f,y)-sets[k].s-per+1<0)sk=-1;
    else sk=(min(sets[k].f,y)-sets[k].s-per+1)/per;
    perend=sets[k].s+sk*per+per-1;    
    if(perend>=perbeg)res+=((perend-perbeg+1)/per)*sets[k].a;
    // preperiod
    s=perbeg-per;
    t=s+sets[k].a-1;
    if(s<x)s=x;
    if(s<sets[k].s)s=sets[k].s;
    if(t>y)t=y;
    if(t>sets[k].f)t=sets[k].f;
    if(s<=t)res+=t-s+1;
    s1=s;t1=t;
    // postperiod
    s=perend+1;
    t=s+sets[k].a-1;
    if(s<x)s=x;
    if(s<sets[k].s)s=sets[k].s;
    if(t>y)t=y;
    if(t>sets[k].f)t=sets[k].f;
    if((s1>t||t1<s)&&s<=t)res+=t-s+1;     
    return res;
}

inline ll ElCnt(int x,int y) {
    ll res=0;
    int k;
    for(k=0;k<n;k++)res+=ElCnt(k,x,y);
    return res;
}

int main() {
    int i;
    int minx,maxx,midx;
    FILE *ifs=fopen(infile,"r");
    FILE *ofs=fopen(outfile,"w");
    
    fscanf(ifs,"%d",&n);
    for(i=0;i<n;i++) {
        fscanf(ifs,"%d%d%d%d",&sets[i].s,&sets[i].f,&sets[i].a,&sets[i].b);
        if(!i||minx>sets[i].s)minx=sets[i].s;
        if(!i||maxx<sets[i].f)maxx=sets[i].f;
    }
    if(ElCnt(minx,maxx)%2==0)fprintf(ofs,"0\n");
    else {
        while(minx!=maxx) { 
            midx=(minx+maxx)/2;
            if(ElCnt(minx,midx)%2)maxx=midx;
            else if(ElCnt(midx+1,maxx)%2)minx=midx+1;    
            else printf("BUG\n"),minx=maxx;
        }
        fprintf(ofs,"%d\n",minx);
    }
    fclose(ifs);
    fclose(ofs);
    return 0;
}
